/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package heatmap;

import java.awt.Point;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.List;

/**
 * creates HeatMaps from the deathLog and positionLog. Also calculates average
 * time users needed for a level.
 *
 * <p>
 * // TODO create HeatMaps for all given levels (not only the first 2).
 * // also, this class really needs refactoring.
 * @author sam
 */
public class EvaluateLogs {

    private List<Point> pointslvl1 = new LinkedList<Point>();
    private List<Point> pointslvl2 = new LinkedList<Point>();
    private List<Point> pointslvl3 = new LinkedList<Point>();
    private List<Point> pointslvl4 = new LinkedList<Point>();
    private List<Point> pointslvl5 = new LinkedList<Point>();
    private static final String USERDIR = System.getProperty("user.dir");
    private static final String RESULTDIR = USERDIR
            + "/heatmap/results/";

    /**
     * loads the points from the deathLog and sorts them according to level.
     *
     * @param log log
     */
    private void loadPoints(String log) {
        pointslvl1 = new LinkedList<Point>();
        pointslvl2 = new LinkedList<Point>();
        pointslvl3 = new LinkedList<Point>();
        pointslvl4 = new LinkedList<Point>();
        pointslvl5 = new LinkedList<Point>();
        try {
            FileInputStream fstream = new FileInputStream(
                    USERDIR + log);
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String strLine;
            while ((strLine = br.readLine()) != null) {
                try {
                    String[] split = strLine.split(";");
                    String[] point = split[2].split(" ");
                    if (split[1].contains("1")) {
                        pointslvl1.add(new Point(Integer.valueOf(point[0]),
                                Integer.valueOf(point[1])));
                    } else if (split[1].contains("2")) {
                        pointslvl2.add(new Point(Integer.valueOf(point[0]),
                                Integer.valueOf(point[1])));
                    } else if (split[1].contains("3")) {
                        pointslvl3.add(new Point(Integer.valueOf(point[0]),
                                Integer.valueOf(point[1])));
                    } else if (split[1].contains("4")) {
                        pointslvl4.add(new Point(Integer.valueOf(point[0]),
                                Integer.valueOf(point[1])));
                    } else if (split[1].contains("5")) {
                        pointslvl5.add(new Point(Integer.valueOf(point[0]),
                                Integer.valueOf(point[1])));
                    }

                } catch (Exception e) {
                    System.out.println("could not parse: "
                            + e + "    " + strLine);
                }
            }
            br.close();
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
    }

    /**
     * creates HeatMap from logs.
     */
    public void createMap() {
        // create death HeatMaps
        loadPoints("/logs/deathLog");
        HeatMapNew h = new HeatMapNew(pointslvl1,
                RESULTDIR + "heatmapLvl1.png",
                RESULTDIR + "lvl1.png");
        h.createHeatMap(6f);
        HeatMapNew h2 = new HeatMapNew(pointslvl2,
                RESULTDIR + "heatmapLvl2.png",
                RESULTDIR + "lvl2.png");
        h2.createHeatMap(6f);
        HeatMapNew h3 = new HeatMapNew(pointslvl3,
                RESULTDIR + "heatmapLvl3.png",
                RESULTDIR + "lvl3.png");
        h3.createHeatMap(6f);
        HeatMapNew h4 = new HeatMapNew(pointslvl4,
                RESULTDIR + "heatmapLvl4.png",
                RESULTDIR + "lvl4.png");
        h4.createHeatMap(6f);
        HeatMapNew h5 = new HeatMapNew(pointslvl5,
                RESULTDIR + "heatmapLvl5.png",
                RESULTDIR + "lvl5.png");
        h5.createHeatMap(6f);

        // create position HeatMaps
        loadPoints("/logs/positionLog");
        HeatMapNew hp1 = new HeatMapNew(pointslvl1,
                RESULTDIR + "heatmapLvl1Position.png",
                RESULTDIR + "lvl1.png");
        hp1.createHeatMap(6f);
        HeatMapNew hp2 = new HeatMapNew(pointslvl2,
                RESULTDIR + "heatmapLvl2Position.png",
                RESULTDIR + "lvl2.png");
        hp2.createHeatMap(6f);

        HeatMapNew hp3 = new HeatMapNew(pointslvl3,
                RESULTDIR + "heatmapLvl3Position.png",
                RESULTDIR + "lvl3.png");
        hp3.createHeatMap(6f);
        HeatMapNew hp4 = new HeatMapNew(pointslvl4,
                RESULTDIR + "heatmapLvl4Position.png",
                RESULTDIR + "lvl4.png");
        hp4.createHeatMap(6f);
        HeatMapNew hp5 = new HeatMapNew(pointslvl5,
                RESULTDIR + "heatmapLvl5Position.png",
                RESULTDIR + "lvl5.png");
        hp5.createHeatMap(6f);

        // calculate average time per lvl
        calculateAverageTime();
    }

    /**
     * calculate average time it took to complete level.
     */
    private void calculateAverageTime() {
        List<Integer> timelvl1 = new LinkedList<Integer>();
        List<Integer> timelvl2 = new LinkedList<Integer>();
        List<Integer> timelvl3 = new LinkedList<Integer>();
        List<Integer> timelvl4 = new LinkedList<Integer>();
        List<Integer> timelvl5 = new LinkedList<Integer>();
        try {
            FileInputStream fstream = new FileInputStream(
                    USERDIR + "/logs/lvlCompleteLog");
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String strLine;
            while ((strLine = br.readLine()) != null) {
                try {
                    String[] split = strLine.split(";");
                    Integer time = Integer.valueOf(split[2]);
                    if (split[1].contains("1")) {
                        timelvl1.add(time);
                    } else if (split[1].contains("2")) {
                        timelvl2.add(time);
                    } else if (split[1].contains("3")) {
                        timelvl3.add(time);
                    } else if (split[1].contains("4")) {
                        timelvl4.add(time);
                    } else if (split[1].contains("5")) {
                        timelvl4.add(time);
                    }
                } catch (Exception e) {
                    System.out.println("could not parse: "
                            + e + "    " + strLine);
                }
            }
            br.close();
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }


        StringBuffer avgTimes = new StringBuffer(65);
        avgTimes.append("\nLevel 1: ");
        avgTimes.append(calcAverage(timelvl1));
        avgTimes.append("\nLevel 2: ");
        avgTimes.append(calcAverage(timelvl2));
        avgTimes.append("\nLevel 3: ");
        avgTimes.append(calcAverage(timelvl3));
        avgTimes.append("\nLevel 4: ");
        avgTimes.append(calcAverage(timelvl4));
        avgTimes.append("\nLevel 5: ");
        avgTimes.append(calcAverage(timelvl5));

        String path = USERDIR
                + System.getProperty("file.separator");

        try {
            FileWriter fw = new FileWriter(path
                    + "heatmap/results/averageTime", false);
            try {
                fw.write(avgTimes.toString());
            } finally {
                fw.close();
            }
        } catch (IOException ioe) {
            System.out.println("log(): ERROR writing to log:"
                    + path + "HeatMap/averageTime: " + ioe);
        }
    }

    /**
     * calculates average of given list.
     *
     * @param list list
     * @return average
     */
    private int calcAverage(List<Integer> list) {
        int avg = 0;
        for (Integer integer : list) {
            avg += integer;
        }
        avg = avg / list.size();
        return avg;
    }

    /**
     * starts to create HeatMap.
     *
     * @param args args
     */
    public static void main(String[] args) {
        EvaluateLogs h = new EvaluateLogs();
        h.createMap();
    }
}