/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sidescroller;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.geom.Shape;
import org.newdawn.slick.geom.Vector2f;

/**
 * A Collectable is an Item that may be collected by the player.
 *
 * @author sam
 */
public class Collectable extends CollidableImageObject {

    /** the value of this collectable. */
    private int value = 10;
    /** whether or not this collectable should be drawn. */
    private boolean drawCollectable;

    /**
     * constructs a new Collectable.
     *
     * @param name name
     * @param image image
     * @param position position
     * @param collisionShape collisionShape
     * @param drawCollectable  whether or not this collectable should be drawn
     */
    public Collectable(
            String name, Image image, Vector2f position, Shape collisionShape,
            boolean drawCollectable) {
        super(name, image, position, collisionShape);
        this.drawCollectable = drawCollectable;
    }

    /**
     * returns the value of this collectable.
     *
     * @return value of this collectable
     */
    public int getValue() {
        return value;
    }

    /**
     * returns true, if the given point is close to this collectable.
     *
     * @param x x
     * @param y x
     * @return close to x, y?
     */
    public boolean isCloseTo(float x, float y) {
        int approcimation = GeneralNumbersAndFunctions.ISCLOSETOAPPROCIMATION;
        Shape poly = super.getCollisionShape();
        return (x > poly.getMinX() - approcimation)
                && (x < poly.getMaxX() + approcimation)
                && (y > poly.getMinY() - approcimation)
                && (y < poly.getMaxY() + approcimation);
    }

    /**
     * Collectables are only rendered
     * when their drawCollectable field is set on true.
     *
     * @param graphics graphics context
     */
    @Override
    public void render(Graphics graphics) {
        if (drawCollectable) {
            super.render(graphics);
        }
    }
}
