/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sidescroller;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Polygon;
import org.newdawn.slick.geom.Shape;

/**
 * This class is a simple block (rectangle) implementation of
 * <code>ICollidableObject</code>.
 *
 * @author sam
 */
public class CollisionBlock implements ICollidableObject {

    private Polygon poly;

    /**
     * constructs a new block.
     * Its position will be defined by the given x and y values and its
     * width and higth by the provided values as well.
     *
     * @param x x
     * @param y x
     * @param width width
     * @param higth higth
     */
    public CollisionBlock(int x, int y, int width, int higth) {
        poly = new Polygon(new float[]{
                    x, y,
                    x + width, y,
                    x + width, y + higth,
                    x, y + higth});
    }

    @Override
    public Shape getCollisionShape() {
        return poly;
    }

    @Override
    public Shape getNormalCollisionShape() {
        return poly;
    }

    @Override
    public boolean isCollidingWith(ICollidableObject collidable) {
        return this.getCollisionShape().intersects(
                collidable.getCollisionShape())
                // TODO part below only needed in lvlchooser map
                // (player is smaller than collision shape). change that.
                || this.getCollisionShape().contains(
                collidable.getCollisionShape());
    }

    /**
     * calls the drawCollisionShape method of <code>Graphics</code>
     * with the polygon residing in this class.
     *
     * @param g graphics context
     */
    public void drawCollisionShape(Graphics g) {
        g.draw(poly);
    }

    /**
     * returns true, if the given point is close to this collision block.
     *
     * @param x x
     * @param y y
     * @return is close to this block?
     */
    public boolean isCloseTo(float x, float y) {
        int approcimation = GeneralNumbersAndFunctions.ISCLOSETOAPPROCIMATION;
        return (x > poly.getMinX() - approcimation)
                && (x < poly.getMaxX() + approcimation)
                && (y > poly.getMinY() - approcimation)
                && (y < poly.getMaxY() + approcimation);
    }
}