/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sidescroller;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;

/**
 * This state displays an error screen.
 *
 * @author sam
 */
public class GameErrorState extends BasicGameState {

    private int stateID = -1;
    private String message = "An Error Occured!\n\n"
            + "You may consult the errorLog for a detailed description "
            + "of the error.\n"
            + "An even more detailed description may be available in "
            + "the console.\n\n"
            + "\n\n(Please press Enter to continue to the main menu)\n\n\n";
    private String lastError = "Test: Error 343231";

    /**
     * constructs new error state with given state id.
     *
     * @param stateID stateID
     */
    public GameErrorState(int stateID) {
        super();
        this.stateID = stateID;
    }

    // TODO actually use this method so this class can display the latest error.
    //     also, use this state more, and also make game more stable
    /**
     * set an error to be displayed.
     *
     * @param lastError lastError
     */
    public void setLastError(String lastError) {
        this.lastError = lastError;
    }

    @Override
    public int getID() {
        return this.stateID;
    }

    @Override
    public void init(GameContainer container, StateBasedGame game)
            throws SlickException {
    }

    @Override
    public void render(GameContainer container, StateBasedGame game, Graphics g)
            throws SlickException {
        g.drawString(message + lastError, 5, 5);
    }

    @Override
    public void update(GameContainer container, StateBasedGame game, int delta)
            throws SlickException {
        if (container.getInput().isKeyPressed(Input.KEY_ENTER)) {
            game.enterState(Game.MAINMENUSTATEID);
        }
    }
}
