/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sidescroller;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.geom.Vector2f;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;

/**
 * // TODO actually use this lvl chooser. disadvantage:
 * adding new lvls is less simple.
 * @author sam
 */
public class GameLevelChooserState extends BasicGameState {

    private int stateID = -1;
    private BlockMap map;
    private String lvlchooser;
    private Camera camera;
    // TODO replace Player through lightweight player class here
    private Player player;

    /**
     * construct.
     *
     * @param stateID stateID
     * @param lvlchooser lvlchooser
     */
    public GameLevelChooserState(int stateID, String lvlchooser) {
        super();
        this.stateID = stateID;
        this.lvlchooser = lvlchooser;
    }

    @Override
    public int getID() {
        return this.stateID;
    }

    @Override
    public void init(GameContainer container, StateBasedGame game)
            throws SlickException {
        try {
            map = new BlockMap(lvlchooser);
        } catch (Exception ex) {
            GeneralNumbersAndFunctions.logError(ex.getMessage());
            game.enterState(Game.ERRORSTATEID);
        }

        try {
            // TODO pass actual player name
            player = map.loadPlayer("");
            camera = new Camera(container, map.getTiledMap());
        } catch (Exception ex) {
            GeneralNumbersAndFunctions.logError("GameLevelChooserState.init(): "
                    + "could not load player. " + ex);
            game.enterState(Game.ERRORSTATEID);
        }
    }

    @Override
    public void render(GameContainer container, StateBasedGame game, Graphics g)
            throws SlickException {
        camera.drawMap(g);
        camera.translateGraphics();
        player.render(g);

        if (Settings.debug) {
            map.renderCollisionShapes(g);
        }
    }

    @Override
    public void update(GameContainer container, StateBasedGame game, int delta)
            throws SlickException {
        Input input = container.getInput();
        Vector2f oldPosition = player.getPosition().copy();
        Vector2f position = player.getPosition();
        int tileHeight = map.getTiledMap().getTileHeight();
        if (input.isKeyPressed(Input.KEY_DOWN)) {
            position.set(position.x, position.y + tileHeight);
        } else if (input.isKeyPressed(Input.KEY_UP)) {
            position.set(position.x, position.y - tileHeight);
        } else if (input.isKeyPressed(Input.KEY_LEFT)) {
            position.set(position.x - tileHeight, position.y);
        } else if (input.isKeyPressed(Input.KEY_RIGHT)) {
            position.set(position.x + tileHeight, position.y);
        }
        if (map.isColliding(player)) {
            position.set(oldPosition);
        }

        camera.centerOn(player.getCollisionShape());
    }
}