/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sidescroller;

import java.io.File;
import java.io.IOException;
import java.util.Properties;
import java.io.FileInputStream;
import java.io.FileOutputStream;

/**
 * // TODO rewrite this class. settings should be even easier to add.
 * //   maybe use serializable...
 * //   add keys for player states here, too
 * @author sam
 */
public class Settings {

    private static final String SETTINGSFILEPATH = "settings";
    private Properties properties;

    /* keys. */
    private static final String SOUNDKEY = "sound";
    private static final String SKIPINTROKEY = "scipIntro";
    private static final String DISPLAYWIDTHKEY = "displayWidth";
    private static final String DISPLAYHIGTHKEY = "displayHight";
    private static final String FULLSCREENKEY = "fullscreen";
    private static final String DEBUGKEY = "debug";
    private static final String MOUSEENABLEDKEY = "mouseEnabled";
    private static final String AITOUSEKEY = "usedAI";
    private static final String OPENLEVELSKEY = "openLevels";
    private static final String PLAYERNAMEKEY = "playerName";
    private static final String LOGPOSITIONKEY = "logPosition";
    private static final String LOGDEATHKEY = "logDeath";
    private static final String LOGLVLCOMPLETEKEY = "logLvlComplete";

    /* actual values (default). */
    // TODO make these private and use getters/setters
    protected boolean sound = false;
    protected boolean skipIntro = false;
    protected int displayWidth = 600;
    protected int displayHight = 300;
    protected boolean fullscreen = false;
    public static boolean debug = false;
    protected boolean mouseEnabled = false;
    protected int aiToUse = 1;
    protected int openLevels = 1;
    protected String playerName = "sam";
    protected boolean logPosition = true;
    protected boolean logDeath = true;
    protected boolean logLvlComplete = true;

    /**
     * constructs new settings.
     */
    public Settings() {
        properties = new Properties();
        initSettings();
    }

    private void initSettings() {
        File settingsFile = new File(SETTINGSFILEPATH);
        if (settingsFile.exists()) {
            loadSettings();
        } else {
            setAndSaveSettings();
        }
    }

    private void loadSettings() {
        try {
            FileInputStream fileInputStream
                    = new FileInputStream(new File(SETTINGSFILEPATH));
            try {
                properties.load(fileInputStream);
            } catch (IOException ioe) {
                System.out.println("could not load settings. using default. "
                        + ioe);
                return;
            } finally {
                fileInputStream.close();
            }
        } catch (IOException ex) {
            System.out.println("could not load settings. using default. " + ex);
            return;
        }
        playerName = properties.getProperty(PLAYERNAMEKEY);
        sound = Boolean.parseBoolean(
                properties.getProperty(SOUNDKEY));
        skipIntro = Boolean.parseBoolean(
                properties.getProperty(SKIPINTROKEY));
        displayWidth = Integer.parseInt(
                properties.getProperty(DISPLAYWIDTHKEY));
        displayHight = Integer.parseInt(
                properties.getProperty(DISPLAYHIGTHKEY));
        fullscreen = Boolean.parseBoolean(
                properties.getProperty(FULLSCREENKEY));
        debug = Boolean.parseBoolean(
                properties.getProperty(DEBUGKEY));
        mouseEnabled = Boolean.parseBoolean(
                properties.getProperty(MOUSEENABLEDKEY));
        aiToUse = Integer.parseInt(
                properties.getProperty(AITOUSEKEY));
        openLevels = Integer.parseInt(
                properties.getProperty(OPENLEVELSKEY));

        logPosition = Boolean.parseBoolean(
                properties.getProperty(LOGPOSITIONKEY));
        logDeath = Boolean.parseBoolean(
                properties.getProperty(LOGDEATHKEY));
        logLvlComplete = Boolean.parseBoolean(
                properties.getProperty(LOGLVLCOMPLETEKEY));
    }

    private void setAndSaveSettings() {
        properties.setProperty(PLAYERNAMEKEY, playerName);
        properties.setProperty(SOUNDKEY, String.valueOf(sound));
        properties.setProperty(SKIPINTROKEY, String.valueOf(skipIntro));
        properties.setProperty(DISPLAYWIDTHKEY, String.valueOf(displayWidth));
        properties.setProperty(DISPLAYHIGTHKEY, String.valueOf(displayHight));
        properties.setProperty(FULLSCREENKEY, String.valueOf(fullscreen));
        properties.setProperty(DEBUGKEY, String.valueOf(debug));
        properties.setProperty(MOUSEENABLEDKEY, String.valueOf(mouseEnabled));
        properties.setProperty(AITOUSEKEY, String.valueOf(aiToUse));
        properties.setProperty(OPENLEVELSKEY, String.valueOf(openLevels));

        properties.setProperty(LOGPOSITIONKEY, String.valueOf(logPosition));
        properties.setProperty(LOGDEATHKEY, String.valueOf(logDeath));
        properties.setProperty(LOGLVLCOMPLETEKEY,
                String.valueOf(logLvlComplete));

        try {
            FileOutputStream fileOutputStream
                    = new FileOutputStream(new File(SETTINGSFILEPATH));
            try {
                properties.store(fileOutputStream, "Settings for sidescroller");
            } catch (IOException ioe) {
                System.out.println("could not save settings. " + ioe);
            } finally {
                fileOutputStream.close();
            }
        } catch (IOException ioe) {
            System.out.println("could not save settings. " + ioe);
        }
    }

    public int getAiToUse() {
        return aiToUse;
    }

    public void setAiToUse(int aiToUse) {
        this.aiToUse = aiToUse;
        setAndSaveSettings();
    }

    public int getDisplayHight() {
        return displayHight;
    }

    public void setDisplayHight(int displayHight) {
        this.displayHight = displayHight;
        setAndSaveSettings();
    }

    public int getDisplayWidth() {
        return displayWidth;
    }

    public void setDisplayWidth(int displayWidth) {
        this.displayWidth = displayWidth;
        setAndSaveSettings();
    }

    public boolean isFullscreen() {
        return fullscreen;
    }

    public void setFullscreen(boolean fullscreen) {
        this.fullscreen = fullscreen;
        setAndSaveSettings();
    }

    public boolean isMouseEnabled() {
        return mouseEnabled;
    }

    public void setMouseEnabled(boolean mouseEnabled) {
        this.mouseEnabled = mouseEnabled;
        setAndSaveSettings();
    }

    public boolean isSkipIntro() {
        return skipIntro;
    }

    public void setSkipIntro(boolean skipIntro) {
        this.skipIntro = skipIntro;
        setAndSaveSettings();
    }

    public int getOpenLevels() {
        return openLevels;
    }

    public void setOpenLevels(int openLevels) {
        this.openLevels = openLevels;
        setAndSaveSettings();
    }

    public boolean isSound() {
        return sound;
    }

    public void setSound(boolean sound) {
        this.sound = sound;
        setAndSaveSettings();
    }

    public boolean isLogDeath() {
        return logDeath;
    }

    public void setLogDeath(boolean logDeath) {
        this.logDeath = logDeath;
        setAndSaveSettings();
    }

    public boolean isLogLvlComplete() {
        return logLvlComplete;
    }

    public void setLogLvlComplete(boolean logLvlComplete) {
        this.logLvlComplete = logLvlComplete;
        setAndSaveSettings();
    }

    public boolean isLogPosition() {
        return logPosition;
    }

    public void setLogPosition(boolean logPosition) {
        this.logPosition = logPosition;
        setAndSaveSettings();
    }

    public String getPlayerName() {
        return playerName;
    }

    public void setPlayerName(String playerName) {
        this.playerName = playerName;
        setAndSaveSettings();
    }
}
