/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sidescroller.menu;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;

/**
 * An AbstractMenuItem implementation that uses an Image to represent itself.
 *
 * @author sam
 */
public class MenuItemImage extends AbstractMenuItem {

    /** the image, which is shown to represent this MenuItemImage. */
    private Image img;

    /**
     * constructs a new MenuItemImage.
     *
     * @param img the image, which is shown to represent this MenuItemImage
     * @param xPos the top left x position of this image
     * @param yPos top left y position of this image
     * @param action the action to execute
     */
    public MenuItemImage(Image img, float xPos, float yPos, MenuAction action) {
        super(xPos, yPos, action);
        super.generateSquare(xPos, yPos, img.getWidth(), img.getHeight());
        this.img = img;
    }

    /**
     * draw the image representing this menuitem with the set x/y
     * position and scale.
     *
     * @param grphcs graphics context
     */
    @Override
    public void render(Graphics grphcs) {
        if (action.isActivated()) {
            img.draw(xPos, yPos, scale);
        } else {
            img.draw(xPos, yPos, new Color(1f, 1f, 1f, 0.5f));
        }
    }
}
