/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sidescroller.menu;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.UnicodeFont;

/**
 * An AbstractMenuItem implementation that uses a String to represent itself.
 *
 * @author sam
 */
public class MenuItemString extends AbstractMenuItem {

    private String string;
    // private UnicodeFont fond;

    /**
     * constructs a new MenuItemString.
     *
     * @param string the string, which is shown to represent this MenuItemString
     * @param fond the fond to use (currently disabled)
     * @param xPos the top left x position of this image
     * @param yPos top left y position of this image
     * @param action the action to execute
     */
    public MenuItemString(String string, UnicodeFont fond,
            float xPos, float yPos, MenuAction action) {
        super(xPos, yPos, action);
        //this.fond = fond;
        this.string = string;
        super.generateSquare(xPos, yPos, fond.getWidth(string),
                fond.getHeight(string) / 2f);
    }

    /**
     * draw the image representing this menuitem with the set x/y
     * position and scale.
     *
     * @param grphcs graphics context
     */
    @Override
    public void render(Graphics grphcs) {
        if (action.isActivated()) {
            // FIXME drawString is not working with these font settings.
            // See help menu in GameMenuState for a solution
            // MenuItemString is not rendered
            // (the String is not drawn, everything else works)
            /*
            // change size of font:
            java.awt.Font oldFont = fond.getFont();
            fond = new UnicodeFont(oldFont, (int) (oldFont.getSize() * scale),
             *  // oldFont.isBold(), oldFont.isItalic());
            // draw string
            fond.drawString(xPos, yPos, string);
             *
             */
            Color color = grphcs.getColor();
            if (scale < 1.025f) {
                grphcs.setColor(Color.lightGray);
            } else {
                grphcs.setColor(Color.white);
            }
            grphcs.drawString(string, xPos, yPos);
            grphcs.setColor(color);
        } else { // display darker
            Color color = grphcs.getColor();
            grphcs.setColor(Color.darkGray);
            grphcs.drawString(string, xPos, yPos);
            grphcs.setColor(color);
            //fond.drawString(xPos, yPos, string, new Color(1f, 1f, 1f, 0.5f));
        }
    }

    /**
     * sets the string which represents this menu item.
     *
     * @param string string
     */
    public void setString(String string) {
        this.string = string;
    }
}
